# Developer Platform

<h2 align="center">Spectra Engine Documentation</h2>

<p align="center">All usefull resources related to developing games within the spectra game engine, including per feature documentation and an API reference.</p>

<p align="center"><a href="http://app.gitbook.com/join" class="button primary">Get started</a> </p>

<table data-view="cards"><thead><tr><th></th><th></th><th></th><th data-hidden data-card-target data-type="content-ref"></th><th data-hidden data-card-cover data-type="files"></th></tr></thead><tbody><tr><td><h4><i class="fa-layer-plus">:layer-plus:</i></h4></td><td><strong>Specification</strong></td><td>Learn more about spectras specification including things like naming conventions.</td><td><a href="/spaces/w2h1Vbp6EIu4EqP6irrY/pages/TDMdsJ2Wh3DVDMZPeH6h">/spaces/w2h1Vbp6EIu4EqP6irrY/pages/TDMdsJ2Wh3DVDMZPeH6h</a></td><td><a href="/files/LHIOZGoI6dPF36TuRaxH">/files/LHIOZGoI6dPF36TuRaxH</a></td></tr><tr><td><h4><i class="fa-square-poll-horizontal">:square-poll-horizontal:</i></h4></td><td><strong>Documentation</strong></td><td>Learn all about spectras core systems with it’s in-depth feature documentation.</td><td><a href="/spaces/w2h1Vbp6EIu4EqP6irrY">/spaces/w2h1Vbp6EIu4EqP6irrY</a></td><td><a href="/files/IaUMODRBBSBL8eUaPX09">/files/IaUMODRBBSBL8eUaPX09</a></td></tr><tr><td><h4><i class="fa-terminal">:terminal:</i></h4></td><td><strong>API reference</strong></td><td>Learn about all of spectras built-in functions.</td><td><a href="/spaces/7DIbm2ahFnxqogD27sNm">/spaces/7DIbm2ahFnxqogD27sNm</a></td><td><a href="/files/ebMoLMpZFyLqpzByuzrk">/files/ebMoLMpZFyLqpzByuzrk</a></td></tr></tbody></table>

{% columns %}
{% column %}

### Get setup in no time

Spectra is meticulously documented to ensure that every feature is as easily explained as possible. The documentation is layed out in a way that allows you to learn any specific part of the engine extremely quickly and includes numerous examples to help you build your next game.

Additionally, the api reference is there to further explain functions that the documentation doesn't fully cover.

<a href="/spaces/w2h1Vbp6EIu4EqP6irrY" class="button primary" data-icon="rocket-launch">Get started</a> <a href="/spaces/7DIbm2ahFnxqogD27sNm" class="button secondary" data-icon="terminal">API reference</a>
{% endcolumn %}

{% column %}
{% code title="Game.cpp" overflow="wrap" %}

```cpp
// Include Spectra
#include <Spectra/core.h>

class TestGame : public GameCore {
    Engine engine = {};

    void initialize(stGameInitInfo* initData) override {
        engine = EngineLoader.get(initData.engineID);
        
        engine.log("Running!")        
    }
    
    void destruct(stGameDestructInfo* destructData) override {
        engine.log("Shutting Down!")
    }
}

```

{% endcode %}
{% endcolumn %}
{% endcolumns %}

<h2 align="center">Join our community</h2>

<p align="center">Join our Discord community or checkout spectras github repositories.</p>

<table data-card-size="large" data-view="cards"><thead><tr><th></th><th></th><th></th><th></th><th data-hidden data-card-cover data-type="files"></th></tr></thead><tbody><tr><td><h4><i class="fa-discord">:discord:</i></h4></td><td><strong>Discord community</strong></td><td>Join our Discord community to post questions, get help, and share resources with the full spectra team.</td><td><a href="https://discord.gg/3JvP5dAsJa" class="button secondary">Join Discord</a></td><td></td></tr><tr><td><h4><i class="fa-github">:github:</i></h4></td><td><strong>GitHub</strong></td><td>Our product is fully open source and built by developers just like you. </td><td><a href="https://www.gitbook.com/" class="button secondary">Spectra Github</a></td><td></td></tr><tr><td></td><td></td><td></td><td></td><td></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.spectraengine.org/readme.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
